#include "Deploy.hpp"

#include <Launcher.hpp>

/*
 * The "static" includes (the one we use inconditionnaly)
 */

int main(int argc, char **argv) {
    int ret = EXIT_SUCCESS;

    // deploy the system corresponding to the root component
    Component &component = *deploy(argc, argv);

    // create an engine launcher
    Launcher launcher(argc, argv, component);

    // initialize the launcher (components, etc.)
    ret = launcher.initialize();

    // run the engine
    if (ret == EXIT_SUCCESS) {
      ret = launcher.launch();
    }

    return ret;
}

Component* deploy(int argc __attribute__((unused)), char **argv __attribute__((unused))){
    // Top is Comp__ROOT





    staticallocated::port__ROOT__environment__sendInput.addInternalPort(staticallocated::iport__ROOT__environment__sendInput);

    staticallocated::port__ROOT__environment__getInput.addInternalPort(staticallocated::iport__ROOT__environment__getInput);

    staticallocated::port__ROOT__environment__getInputInitial.addInternalPort(staticallocated::iport__ROOT__environment__getInputInitial);

    staticallocated::port__ROOT__environment__noInput.addInternalPort(staticallocated::iport__ROOT__environment__noInput);

    // Runtime init for Atom: Comp__ROOT__environment
    // staticallocated::Comp__ROOT__environment




    staticallocated::port__ROOT__camera__capture.addInternalPort(staticallocated::iport__ROOT__camera__capture);

    staticallocated::port__ROOT__camera__sendInput.addInternalPort(staticallocated::iport__ROOT__camera__sendInput);

    // Runtime init for Atom: Comp__ROOT__camera
    // staticallocated::Comp__ROOT__camera






    staticallocated::port__ROOT__perception__getInput.addInternalPort(staticallocated::iport__ROOT__perception__getInput);

    staticallocated::port__ROOT__perception__sendResult.addInternalPort(staticallocated::iport__ROOT__perception__sendResult);

    staticallocated::port__ROOT__perception__noDetection.addInternalPort(staticallocated::iport__ROOT__perception__noDetection);

    staticallocated::port__ROOT__perception__inference.addInternalPort(staticallocated::iport__ROOT__perception__inference);

    // Runtime init for Atom: Comp__ROOT__perception
    // staticallocated::Comp__ROOT__perception








    staticallocated::port__ROOT__controller__getSpeedLimit.addInternalPort(staticallocated::iport__ROOT__controller__getSpeedLimit);

    staticallocated::port__ROOT__controller__completed.addInternalPort(staticallocated::iport__ROOT__controller__completed);

    // Runtime init for Atom: Comp__ROOT__controller
    // staticallocated::Comp__ROOT__controller























    // Runtime init for Compound: Comp__ROOT
    // staticallocated::Comp__ROOT

    // Finished: Comp__ROOT
    return &(staticallocated::Comp__ROOT);
}

bool isSerializeEnabled() {
    return false;
}

void serialize(char **cbuf __attribute__((unused)), size_t *clen __attribute__((unused))){
    assert(false);
}

void deserialize(const char *buf __attribute__((unused)), size_t len __attribute__((unused))){
    assert(false);
}
