// here we should have includes for all used types
// from all packages.
#include "DeployTypes.hpp"

Component* deploy(int argc, char **argv);
bool isSerializeEnabled();
void serialize(char **buf, size_t *len);
void deserialize(const char *buf, size_t len);

namespace staticallocated{

    // data param for Comp__ROOT./
    

    AtomIPort__learn__floatPort iport__ROOT__environment__sendInput("sendInput");

    AtomIPort__learn__silent iport__ROOT__environment__getInput("getInput");

    AtomIPort__learn__silent iport__ROOT__environment__getInputInitial("getInputInitial");

    AtomIPort__learn__silent iport__ROOT__environment__noInput("noInput");

    AtomEPort__learn__floatPort port__ROOT__environment__sendInput("sendInput", false);

    AtomEPort__learn__silent port__ROOT__environment__getInput("getInput", false);

    AtomEPort__learn__silent port__ROOT__environment__getInputInitial("getInputInitial", false);

    AtomEPort__learn__silent port__ROOT__environment__noInput("noInput", false);

    // static init for Atom: Comp__ROOT__environment
    

    AT__learn__Environment Comp__ROOT__environment(
     "environment"
     , iport__ROOT__environment__sendInput, iport__ROOT__environment__getInput, iport__ROOT__environment__getInputInitial, iport__ROOT__environment__noInput
     
     , port__ROOT__environment__sendInput, port__ROOT__environment__getInput, port__ROOT__environment__getInputInitial, port__ROOT__environment__noInput
     
     
    );


    AtomIPort__learn__floatPort iport__ROOT__camera__capture("capture");

    AtomIPort__learn__floatPort iport__ROOT__camera__sendInput("sendInput");

    AtomEPort__learn__floatPort port__ROOT__camera__capture("capture", false);

    AtomEPort__learn__floatPort port__ROOT__camera__sendInput("sendInput", false);

    // static init for Atom: Comp__ROOT__camera
    

    AT__learn__Camera Comp__ROOT__camera(
     "camera"
     , iport__ROOT__camera__capture, iport__ROOT__camera__sendInput
     
     , port__ROOT__camera__capture, port__ROOT__camera__sendInput
     
     
    );


    AtomIPort__learn__floatPort iport__ROOT__perception__getInput("getInput");

    AtomIPort__learn__floatPort iport__ROOT__perception__sendResult("sendResult");

    AtomIPort__learn__silent iport__ROOT__perception__noDetection("noDetection");

    AtomIPort__learn__silent iport__ROOT__perception__inference("inference");

    AtomEPort__learn__floatPort port__ROOT__perception__getInput("getInput", false);

    AtomEPort__learn__floatPort port__ROOT__perception__sendResult("sendResult", false);

    AtomEPort__learn__silent port__ROOT__perception__noDetection("noDetection", false);

    AtomEPort__learn__silent port__ROOT__perception__inference("inference", false);

    // static init for Atom: Comp__ROOT__perception
    

    AT__learn__Perception Comp__ROOT__perception(
     "perception"
     , iport__ROOT__perception__getInput, iport__ROOT__perception__sendResult, iport__ROOT__perception__noDetection, iport__ROOT__perception__inference
     
     , port__ROOT__perception__getInput, port__ROOT__perception__sendResult, port__ROOT__perception__noDetection, port__ROOT__perception__inference
     
     
    );


    AtomIPort__learn__floatPort iport__ROOT__controller__getSpeedLimit("getSpeedLimit");

    AtomIPort__learn__floatPort iport__ROOT__controller__getSpeed("getSpeed");

    AtomIPort__learn__floatPort iport__ROOT__controller__brake("brake");

    AtomIPort__learn__floatPort iport__ROOT__controller__throttle("throttle");

    AtomIPort__learn__floatPort iport__ROOT__controller__noSpeedChange("noSpeedChange");

    AtomIPort__learn__silent iport__ROOT__controller__completed("completed");

    AtomEPort__learn__floatPort port__ROOT__controller__getSpeedLimit("getSpeedLimit", false);

    AtomEPort__learn__silent port__ROOT__controller__completed("completed", false);

    // static init for Atom: Comp__ROOT__controller
    

    AT__learn__Controller Comp__ROOT__controller(
     "controller"
     , iport__ROOT__controller__getSpeedLimit, iport__ROOT__controller__getSpeed, iport__ROOT__controller__brake, iport__ROOT__controller__throttle, iport__ROOT__controller__noSpeedChange, iport__ROOT__controller__completed
     
     , port__ROOT__controller__getSpeedLimit, port__ROOT__controller__completed
     
     
    );


    QPR__learn__floatPort ref__ROOT__capture__p1(port__ROOT__environment__sendInput, false);

    QPR__learn__floatPort ref__ROOT__capture__p2(port__ROOT__camera__capture, false);

    ConnT__learn__floatConnector Conn__ROOT__capture(
        "capture",
        ref__ROOT__capture__p1, ref__ROOT__capture__p2
        
        );

    QPR__learn__floatPort ref__ROOT__getPerceptionInput__p1(port__ROOT__camera__sendInput, false);

    QPR__learn__floatPort ref__ROOT__getPerceptionInput__p2(port__ROOT__perception__getInput, false);

    ConnT__learn__floatConnector Conn__ROOT__getPerceptionInput(
        "getPerceptionInput",
        ref__ROOT__getPerceptionInput__p1, ref__ROOT__getPerceptionInput__p2
        
        );

    QPR__learn__floatPort ref__ROOT__getSpeedLimit__p1(port__ROOT__perception__sendResult, false);

    QPR__learn__floatPort ref__ROOT__getSpeedLimit__p2(port__ROOT__controller__getSpeedLimit, false);

    ConnT__learn__floatConnector Conn__ROOT__getSpeedLimit(
        "getSpeedLimit",
        ref__ROOT__getSpeedLimit__p1, ref__ROOT__getSpeedLimit__p2
        
        );

    QPR__learn__silent ref__ROOT__nextFrame__p1(port__ROOT__controller__completed, false);

    QPR__learn__silent ref__ROOT__nextFrame__p3(port__ROOT__environment__getInput, false);

    ConnT__learn__rendezVous Conn__ROOT__nextFrame(
        "nextFrame",
        ref__ROOT__nextFrame__p1, ref__ROOT__nextFrame__p3
        
        );

    QPR__learn__silent ref__ROOT__noDetection__p1(port__ROOT__perception__noDetection, false);

    QPR__learn__silent ref__ROOT__noDetection__p2(port__ROOT__environment__getInput, false);

    ConnT__learn__NoDetection Conn__ROOT__noDetection(
        "noDetection",
        ref__ROOT__noDetection__p1, ref__ROOT__noDetection__p2
        
        );

    QPR__learn__silent ref__ROOT__inference__p1(port__ROOT__perception__inference, false);

    ConnT__learn__singleton Conn__ROOT__inference(
        "inference",
        ref__ROOT__inference__p1
        
        );

    QPR__learn__silent ref__ROOT__noInput__p1(port__ROOT__environment__noInput, false);

    ConnT__learn__singleton Conn__ROOT__noInput(
        "noInput",
        ref__ROOT__noInput__p1
        
        );

    QPR__learn__silent ref__ROOT__getInputInitial__p1(port__ROOT__environment__getInputInitial, false);

    ConnT__learn__singleton Conn__ROOT__getInputInitial(
        "getInputInitial",
        ref__ROOT__getInputInitial__p1
        
        );

    // static init for Compound: Comp__ROOT

    CT__learn__Compound Comp__ROOT(
      "ROOT"
     , Comp__ROOT__environment, Comp__ROOT__camera, Comp__ROOT__perception, Comp__ROOT__controller
     
     , Conn__ROOT__capture, Conn__ROOT__getPerceptionInput, Conn__ROOT__getSpeedLimit, Conn__ROOT__nextFrame, Conn__ROOT__noDetection, Conn__ROOT__inference, Conn__ROOT__noInput, Conn__ROOT__getInputInitial
     
     
     
     
    );


// End of namespace.
};
